
package de.ivu.elect.presentation.benutzerverwaltung;

import javax.annotation.PostConstruct;
import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.benutzerverwaltung.boundary.BenutzerEinsatzortBoundaryCreate;
import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzort;
import de.ivu.elect.business.benutzerverwaltung.entity.BenutzerEinsatzortMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractBenutzerEinsatzortCreateNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractBenutzerEinsatzortCreateNoScopeView.VIEW_ID, useCase = UseCasePermission.BENUTZER_EINSATZORT_CREATE)
public abstract class AbstractBenutzerEinsatzortCreateNoScopeView extends de.ivu.elect.presentation.AbstractElectCreateView<BenutzerEinsatzort> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "benutzerEinsatzortCreateView";

  public static final String VIEW_ID = "/benutzerverwaltung/benutzer-einsatzort-create.xhtml";

  public static final String PARENT_VIEW_ID = "/benutzerverwaltung/benutzer-einsatzort-search.xhtml";

  @Inject
  protected transient BenutzerEinsatzortBoundaryCreate create;

  protected BenutzerEinsatzort entity;

  @Inject
  protected transient BenutzerEinsatzortMeta entityMeta;

  
  @PostConstruct
  public void init() {
    setEntity(new  BenutzerEinsatzort());
  }

  

  public BenutzerEinsatzort getEntity() {
    return entity;
  }

  protected void setEntity(BenutzerEinsatzort entity) {
    this.entity = entity;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.BENUTZER_EINSATZORT_CREATE)
  public String save() {
    callSave(getEntity());

    addMessageSaveSuccess(getEntity());

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(BenutzerEinsatzort entity) {
    create.save(entity);
  }

  protected void addMessageSaveSuccess(BenutzerEinsatzort entity) {
    addInfoMessage("entity.create.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnSaveRendered() {
    return hasPermission(UseCasePermission.BENUTZER_EINSATZORT_CREATE);
  }

  @Redirect
  public String reset() {
    resetStateAfterAction();

    init();

    return getViewId();
  }

  public boolean isBtnResetRendered() {
    return true;
  }

  @Redirect
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  public boolean isBtnCancelRendered() {
    return true;
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    // Do nothing.
  }
}
